"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DaoWorldsActionProcessorTaskMapper = exports.DaoWorldsActionMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const appointcust_mapper_1 = require("./appointcust.mapper");
const balanceobsv_mapper_1 = require("./balanceobsv.mapper");
const claimbudget_mapper_1 = require("./claimbudget.mapper");
const claimpay_mapper_1 = require("./claimpay.mapper");
const firecand_mapper_1 = require("./firecand.mapper");
const firecust_mapper_1 = require("./firecust.mapper");
const flagcandprof_mapper_1 = require("./flagcandprof.mapper");
const newperiod_mapper_1 = require("./newperiod.mapper");
const nominate_mapper_1 = require("./nominate.mapper");
const nominatecane_mapper_1 = require("./nominatecane.mapper");
const paycpu_mapper_1 = require("./paycpu.mapper");
const regproxy_mapper_1 = require("./regproxy.mapper");
const rejectcuspay_mapper_1 = require("./rejectcuspay.mapper");
const removecand_mapper_1 = require("./removecand.mapper");
const removecstvte_mapper_1 = require("./removecstvte.mapper");
const removecuspay_mapper_1 = require("./removecuspay.mapper");
const resigncust_mapper_1 = require("./resigncust.mapper");
const runnewperiod_mapper_1 = require("./runnewperiod.mapper");
const setbudget_mapper_1 = require("./setbudget.mapper");
const setperm_mapper_1 = require("./setperm.mapper");
const stakeobsv_mapper_1 = require("./stakeobsv.mapper");
const stprofile_mapper_1 = require("./stprofile.mapper");
const unregproxy_mapper_1 = require("./unregproxy.mapper");
const unsetbudget_mapper_1 = require("./unsetbudget.mapper");
const updatebio_mapper_1 = require("./updatebio.mapper");
const updateconfige_mapper_1 = require("./updateconfige.mapper");
const updatereqpay_mapper_1 = require("./updatereqpay.mapper");
const votecust_mapper_1 = require("./votecust.mapper");
const voteproxy_mapper_1 = require("./voteproxy.mapper");
const weightobsv_mapper_1 = require("./weightobsv.mapper");
const withdrawcane_mapper_1 = require("./withdrawcane.mapper");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const enums_1 = require("../../domain/enums");
class DaoWorldsActionMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    fromEntity(entity) {
        let entityData;
        switch (entity.name) {
            case enums_1.DaoWorldsActionName.Appointcust:
                entityData = new appointcust_mapper_1.AppointcustMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Balanceobsv:
                entityData = new balanceobsv_mapper_1.BalanceobsvMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Claimbudget:
                entityData = new claimbudget_mapper_1.ClaimbudgetMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Claimpay:
                entityData = new claimpay_mapper_1.ClaimpayMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Firecand:
                entityData = new firecand_mapper_1.FirecandMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Firecust:
                entityData = new firecust_mapper_1.FirecustMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Flagcandprof:
                entityData = new flagcandprof_mapper_1.FlagcandprofMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Newperiod:
                entityData = new newperiod_mapper_1.NewperiodMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Nominate:
                entityData = new nominate_mapper_1.NominateMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Nominatecane:
                entityData = new nominatecane_mapper_1.NominatecaneMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Paycpu:
                entityData = new paycpu_mapper_1.PaycpuMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Regproxy:
                entityData = new regproxy_mapper_1.RegproxyMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Rejectcuspay:
                entityData = new rejectcuspay_mapper_1.RejectcuspayMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Removecand:
                entityData = new removecand_mapper_1.RemovecandMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Removecstvte:
                entityData = new removecstvte_mapper_1.RemovecstvteMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Removecuspay:
                entityData = new removecuspay_mapper_1.RemovecuspayMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Resigncust:
                entityData = new resigncust_mapper_1.ResigncustMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Runnewperiod:
                entityData = new runnewperiod_mapper_1.RunnewperiodMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Setbudget:
                entityData = new setbudget_mapper_1.SetbudgetMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Setperm:
                entityData = new setperm_mapper_1.SetpermMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Stakeobsv:
                entityData = new stakeobsv_mapper_1.StakeobsvMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Stprofile:
                entityData = new stprofile_mapper_1.StprofileMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Unregproxy:
                entityData = new unregproxy_mapper_1.UnregproxyMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Unsetbudget:
                entityData = new unsetbudget_mapper_1.UnsetbudgetMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Updatebio:
                entityData = new updatebio_mapper_1.UpdatebioMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Updateconfige:
                entityData = new updateconfige_mapper_1.UpdateconfigeMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Updatereqpay:
                entityData = new updatereqpay_mapper_1.UpdatereqpayMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Votecust:
                entityData = new votecust_mapper_1.VotecustMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Voteproxy:
                entityData = new voteproxy_mapper_1.VoteproxyMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Weightobsv:
                entityData = new weightobsv_mapper_1.WeightobsvMongoMapper().fromEntity(entity.data);
                break;
            case enums_1.DaoWorldsActionName.Withdrawcane:
                entityData = new withdrawcane_mapper_1.WithdrawcaneMongoMapper().fromEntity(entity.data);
                break;
        }
        const model = {
            block_timestamp: entity.blockTimestamp,
            block_number: new aw_storage_mongodb_1.MongoDB.Long(entity.blockNumber),
            global_sequence: new aw_storage_mongodb_1.MongoDB.Long(entity.globalSequence),
            receiver_sequence: new aw_storage_mongodb_1.MongoDB.Long(entity.receiverSequence),
            trx_id: entity.transactionId,
            action: {
                name: entity.name,
                account: entity.account,
                data: entityData,
            },
        };
        if (entity.id && aw_storage_mongodb_1.MongoDB.ObjectId.isValid(entity.id)) {
            model._id = new aw_storage_mongodb_1.MongoDB.ObjectId(entity.id);
        }
        return model;
    }
    toEntity(mongoModel) {
        let data;
        switch (mongoModel.action.name) {
            case enums_1.DaoWorldsActionName.Appointcust:
                data = new appointcust_mapper_1.AppointcustMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Balanceobsv:
                data = new balanceobsv_mapper_1.BalanceobsvMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Claimbudget:
                data = new claimbudget_mapper_1.ClaimbudgetMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Claimpay:
                data = new claimpay_mapper_1.ClaimpayMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Firecand:
                data = new firecand_mapper_1.FirecandMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Firecust:
                data = new firecust_mapper_1.FirecustMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Flagcandprof:
                data = new flagcandprof_mapper_1.FlagcandprofMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Newperiod:
                data = new newperiod_mapper_1.NewperiodMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Nominate:
                data = new nominate_mapper_1.NominateMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Nominatecane:
                data = new nominatecane_mapper_1.NominatecaneMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Paycpu:
                data = new paycpu_mapper_1.PaycpuMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Regproxy:
                data = new regproxy_mapper_1.RegproxyMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Rejectcuspay:
                data = new rejectcuspay_mapper_1.RejectcuspayMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Removecand:
                data = new removecand_mapper_1.RemovecandMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Removecstvte:
                data = new removecstvte_mapper_1.RemovecstvteMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Removecuspay:
                data = new removecuspay_mapper_1.RemovecuspayMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Resigncust:
                data = new resigncust_mapper_1.ResigncustMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Runnewperiod:
                data = new runnewperiod_mapper_1.RunnewperiodMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Setbudget:
                data = new setbudget_mapper_1.SetbudgetMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Setperm:
                data = new setperm_mapper_1.SetpermMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Stakeobsv:
                data = new stakeobsv_mapper_1.StakeobsvMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Stprofile:
                data = new stprofile_mapper_1.StprofileMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Unregproxy:
                data = new unregproxy_mapper_1.UnregproxyMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Unsetbudget:
                data = new unsetbudget_mapper_1.UnsetbudgetMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Updatebio:
                data = new updatebio_mapper_1.UpdatebioMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Updateconfige:
                data = new updateconfige_mapper_1.UpdateconfigeMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Updatereqpay:
                data = new updatereqpay_mapper_1.UpdatereqpayMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Votecust:
                data = new votecust_mapper_1.VotecustMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Voteproxy:
                data = new voteproxy_mapper_1.VoteproxyMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Weightobsv:
                data = new weightobsv_mapper_1.WeightobsvMongoMapper().toEntity(mongoModel.action.data);
                break;
            case enums_1.DaoWorldsActionName.Withdrawcane:
                data = new withdrawcane_mapper_1.WithdrawcaneMongoMapper().toEntity(mongoModel.action.data);
                break;
        }
        const { _id, block_timestamp, block_number, global_sequence, receiver_sequence, trx_id, action, } = mongoModel;
        return new aw_core_1.ContractAction(_id.toString(), block_timestamp, (0, aw_core_1.parseToBigInt)(block_number), action.account, action.name, (0, aw_core_1.parseToBigInt)(global_sequence), (0, aw_core_1.parseToBigInt)(receiver_sequence), trx_id, data);
    }
}
exports.DaoWorldsActionMongoMapper = DaoWorldsActionMongoMapper;
class DaoWorldsActionProcessorTaskMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('method not implemented');
    }
    toEntity(rawModel) {
        let data;
        switch (rawModel.name) {
            case enums_1.DaoWorldsActionName.Appointcust:
                data = new appointcust_mapper_1.AppointcustRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Balanceobsv:
                data = new balanceobsv_mapper_1.BalanceobsvRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Claimbudget:
                data = new claimbudget_mapper_1.ClaimbudgetRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Claimpay:
                data = new claimpay_mapper_1.ClaimpayRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Firecand:
                data = new firecand_mapper_1.FirecandRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Firecust:
                data = new firecust_mapper_1.FirecustRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Flagcandprof:
                data = new flagcandprof_mapper_1.FlagcandprofRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Newperiod:
                data = new newperiod_mapper_1.NewperiodRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Nominate:
                data = new nominate_mapper_1.NominateRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Nominatecane:
                data = new nominatecane_mapper_1.NominatecaneRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Paycpu:
                data = new paycpu_mapper_1.PaycpuRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Regproxy:
                data = new regproxy_mapper_1.RegproxyRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Rejectcuspay:
                data = new rejectcuspay_mapper_1.RejectcuspayRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Removecand:
                data = new removecand_mapper_1.RemovecandRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Removecstvte:
                data = new removecstvte_mapper_1.RemovecstvteRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Removecuspay:
                data = new removecuspay_mapper_1.RemovecuspayRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Resigncust:
                data = new resigncust_mapper_1.ResigncustRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Runnewperiod:
                data = new runnewperiod_mapper_1.RunnewperiodRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Setbudget:
                data = new setbudget_mapper_1.SetbudgetRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Setperm:
                data = new setperm_mapper_1.SetpermRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Stakeobsv:
                data = new stakeobsv_mapper_1.StakeobsvRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Stprofile:
                data = new stprofile_mapper_1.StprofileRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Unregproxy:
                data = new unregproxy_mapper_1.UnregproxyRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Unsetbudget:
                data = new unsetbudget_mapper_1.UnsetbudgetRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Updatebio:
                data = new updatebio_mapper_1.UpdatebioRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Updateconfige:
                data = new updateconfige_mapper_1.UpdateconfigeRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Updatereqpay:
                data = new updatereqpay_mapper_1.UpdatereqpayRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Votecust:
                data = new votecust_mapper_1.VotecustRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Voteproxy:
                data = new voteproxy_mapper_1.VoteproxyRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Weightobsv:
                data = new weightobsv_mapper_1.WeightobsvRawMapper().toEntity(rawModel.data);
                break;
            case enums_1.DaoWorldsActionName.Withdrawcane:
                data = new withdrawcane_mapper_1.WithdrawcaneRawMapper().toEntity(rawModel.data);
                break;
        }
        const { account, name, block_timestamp, block_number, global_sequence, recv_sequence, transaction_id, } = rawModel;
        return new aw_core_1.ContractAction('', block_timestamp, (0, aw_core_1.parseToBigInt)(block_number), account, name, (0, aw_core_1.parseToBigInt)(global_sequence), (0, aw_core_1.parseToBigInt)(recv_sequence), transaction_id, data);
    }
}
exports.DaoWorldsActionProcessorTaskMapper = DaoWorldsActionProcessorTaskMapper;
