"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnregproxyRawMapper = exports.UnregproxyMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class UnregproxyMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('proxy', {
            key: 'proxy',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('dacId', {
            key: 'dac_id',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { proxy, dac_id, _id, ...rest } = mongoModel;
        return entities_1.Unregproxy.create(proxy || '', dac_id || '', _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.UnregproxyMongoMapper = UnregproxyMongoMapper;
class UnregproxyRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { proxy, dac_id, ...rest } = rawModel;
        return entities_1.Unregproxy.create(proxy || '', dac_id || '', undefined, rest);
    }
}
exports.UnregproxyRawMapper = UnregproxyRawMapper;
