"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VotesRawMapper = exports.VotesMongoMapper = void 0;
const aw_core_1 = require("@alien-worlds/aw-core");
const aw_storage_mongodb_1 = require("@alien-worlds/aw-storage-mongodb");
const entities_1 = require("../../domain/entities");
class VotesMongoMapper extends aw_storage_mongodb_1.MongoMapper {
    constructor() {
        super();
        this.mappingFromEntity.set('voter', {
            key: 'voter',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('proxy', {
            key: 'proxy',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('candidates', {
            key: 'candidates',
            mapper: (values) => values,
        });
        this.mappingFromEntity.set('voteTimeStamp', {
            key: 'vote_time_stamp',
            mapper: (value) => value,
        });
        this.mappingFromEntity.set('voteCount', {
            key: 'vote_count',
            mapper: (value) => value,
        });
    }
    toEntity(mongoModel) {
        const { voter, proxy, candidates, vote_time_stamp, vote_count, _id, ...rest } = mongoModel;
        return entities_1.Votes.create(voter || '', proxy || '', candidates || [], vote_time_stamp || new Date(0), vote_count || 0, _id instanceof aw_storage_mongodb_1.MongoDB.ObjectId ? _id.toString() : undefined, rest);
    }
}
exports.VotesMongoMapper = VotesMongoMapper;
class VotesRawMapper extends aw_core_1.MapperImpl {
    fromEntity(entity) {
        throw new Error('Method not implemented');
    }
    toEntity(rawModel) {
        const { voter, proxy, candidates, vote_time_stamp, vote_count, ...rest } = rawModel;
        return entities_1.Votes.create(voter || '', proxy || '', candidates || [], vote_time_stamp || new Date(0), vote_count || 0, undefined, rest);
    }
}
exports.VotesRawMapper = VotesRawMapper;
